function []=skm_3dof_Jacobian()
clc;
D2R=pi/180;
% Robot parameters %
a1=	0.1; a2=0.07; a3=0.05;      % [m]
param=[0,a1,0; 0,a2,0;0,a3,0];

th=D2R*[0,90,0]';
 
[J]=Jacobian_Matrix(th, param);

% Joint Velocities %
v=[0.1,0.1,0]';   % [m/s] & [rad/s]
th_dot=inv(J)*v;
 
% Joint torques %
f=[0,10,0]';       % [N] & [Nm]
tau=J'*f;
 
disp('Jacobian Matrix');
disp(J);
disp('Joint velocity [rad/s]');
disp(th_dot');
disp('Joint torques [Nm]');
disp(tau');

function [J]=Jacobian_Matrix(th, param)
a1=param(1,2); a2=param(2,2); a3=param(3,2);
th1=th(1,1); th2=th(2,1); th3=th(3,1);
% Jacobian Matrix %
J=[-a1*sin(th1)-a2*sin(th1+th2)-a3*sin(th1+th2+th3), -a2*sin(th1+th2)-a3*sin(th1+th2+th3), -a3*sin(th1+th2+th3);...
   +a1*cos(th1)+a2*cos(th1+th2)-a3*cos(th1+th2+th3), +a2*cos(th1+th2)+a3*cos(th1+th2+th3), +a3*cos(th1+th2+th3);
   1,1,1];
